unit UEspec;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBiProcs, DBCtrls, Buttons, Mask, Grids, DBGrids, ExtCtrls, Db, DBTables,
  RpCon, RpConDS, RpBase, RpSystem, RpDefine, RpRave, ExceptionLog,
  DBClient, Menus, Gauges, XPMan;

type
  TFormFormulas = class(TForm)
    PainelDeFormulas: TPanel;
    BotSairFormulas: TBitBtn;
    PainelLogin: TPanel;
    Bevel10: TBevel;
    Label216: TLabel;
    Label217: TLabel;
    Panel48: TPanel;
    EditNome: TEdit;
    EditSenhaU: TEdit;
    BotOkSenha: TBitBtn;
    BotCancSenha: TBitBtn;
    PainelPesquisa: TPanel;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    procedure BotSairFormulasClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BotOkSenhaClick(Sender: TObject);
    procedure BotCancSenhaClick(Sender: TObject);
    procedure EditNomeExit(Sender: TObject);
    procedure EditNomeKeyPress(Sender: TObject; var Key: Char);
    procedure EditSenhaUKeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Migrando: Boolean;
  Cod_For: integer;
  Cod_Lagf: integer;
  Sistema: String[10];
  Nome: String[60];
  Permissoes: String[50];

  FormFormulas: TFormFormulas;
  CorFundo: Tcolor;
  Marca: TBookmark;
  QdeComp: Integer;
  TemCap,
  TemVol : Boolean;
  Estilo  : TFontStyles;
  Origem : String;
  Destinos: String;
  Habilita: LongInt;

  // Para LogOn
  Usuario: String[60];
  PL: String[60];
  FecharPrograma: Boolean;
  EstLocal: String[2];

  PastaEXE, CaminhoBkp: string;
  IPServidor: string[60];
  IPEstacao,
  IPBkpPed,
  IPBackup: string[40];
  // PARSIST - INICIO
  FazLog: string[3];
  Padrao_Pr_Min,
  Botao_Manip_em_Aberto,
  Modelo_da_Requisicao,
  Usar_FC_no_Pr_Venda,
  Atendente_Obrigatorio,
  Mostrar_Precricao_na_Requisicao,
  Mostrar_Desconto_na_Requisicao,
  Usar_Preco_Formula_Predefinida,
  Largura_da_Requisicao,
  Mostra_Convenio_na_Requisicao,
  Salto_Final_Requisicao,
  LOG_Ativado,
  Usar_Preco_Minimo_por_Frasco,
  Arredondamento,
  Margem_Esquerda_Requisicao,
  Incluir_Posologia_na_Requisicao,
  Largura_da_OM,
  Margem_Esquerda_OM,
  Embalagem_Obrigatoria,
  Mostrar_Validade_na_Requisicao,
  Formata_Nome_Cliente,
  Mostrar_Endereco_na_Req,
  Separacao_entre_colunas_Req,
  Alerta_sobre_Validade,
  Forma_Pagto_Obrigatoria,
  Incluir_Obs_na_Requisicao,
  Qde_Dias_Apos_Sexta,
  Qde_Dias_Apos_Outros_Dias,
  Usar_Homeopatia,
  Qde_Gotas_Conta_Gotas,
  Preco_Hom_pela_QdeGotas,
  Habilita_Repetir_Pedido,
  Tipo_Validade_a_Usar,
  Usar_Nome_Form_Predefinida,
  Unidade_Comprimidos_Homeopatia,
  Mostrar_Matricula_na_Req,
  Formato_da_Validade,
  Valor_Hora_Manipulacao,
  Identificacao_Campo_Custos,
  Bloqueio_Alteracao_Pedido,
  Impressao_Obrigatoria,
  Modelo_Requisicao,
  Cabecalho_Portaria_3492,
  Recalc_Data_Pedido,
  Texto_Padrao_Posologia,
  Mostrar_Codigo_Entrega,
  Permitir_Prod_REV,
  Mostrar_Campos_Caixa,
  Cor_Padrao_Capsulas,
  Texto_Campo_Convenio,
  Visualizar_Situacoes_Especiais,
  Laboratorio_Padrao,
  Posologia_Obrigatoria:  string[30];
  // Para OM
  Mostrar_Obs_Dosag_ForaDaFaixa,
  Altura_da_Pagina_OM,
  Margem_Superior_OM,
  Salto_Final_Apos_Impr_OM,
  Modelo_da_OM,
  Fechar_CX_Dialogo,
  Qde_Caps_Se_Desdobr,
  Mostrar_nome_Form_PreDef,
  Mostra_Ficha_Tecnica,
  Mostra_Convenio_na_OM,
  Incluir_Infor_Med_na_OM,
  Converter_ML_para_G_na_OM,
  Mostrar_Densidade_na_OM,
  Destaca_OBS_na_OM,
  Gera_Lote,
  Impr_TracoHoriz_no_Final_OM,
  Permite_Preench_Man_Excip_Vei,
  Utiliza_Param_CQ_na_OM,
  Detalhar_Excip_da_Form_na_OM,
  Texto_Ref_Qde_Real_a_Pesar,
  Excluir_Diluida_da_MP,
  Volume_Total_Formula: string[30];
  // PARSIST - FIM

  // PARSIST2 - INICIO
  Convenio_Padrao: string[40];
  Usar_FD_no_Calc_Preco_Venda,
  Rota_Obrigatoria,
  Inclir_dados_cliente,
  Permite_Form_Hom_Sem_Estoq,
  Ativar_modo_implantacao,
  Impede_digitar_nome_atendente,
  Tempo_para_Logoff_automatico,
  Usar_red_qde_fr_para_DoseUnica,
  Exibir_botao_placebo,
  Limite_reg_quitacao_automat,
  TitCol4FormaFar,
  Utillizar_tab_AcrescHom,
  Precos_Florais_ComBaseNa,
  Precos_Hom_Assoc_ComBase,
  Cor_Mensagens_Componentes,
  Mudanca_cor_sit_especiais,
  Incluir_Exc_e_Vei_nos_Rotulos,
  Incluir_Preco_na_OM_e_Req,
  Incluir_Texto_Pedido_Orcam_Req,
  Mascara_Formatar_N_Pedido,
  Ocultar_Insert_Medico,
  Repetir_OBS_ao_Repetir_Pedido,
  Impedir_Reimpressao_Req,
  Inclusao_Embalagem,
  Obrig_Preench_Dados_SNGPC,
  Utilizacao_de_ECF,
  Mostrar_Excipiente_Formula,
  Definir_o_excip_pela_dosagem,
  Valor_Desconto_Florais,
  Valor_Desc_Brandy,
  Mostrar_Campo_SINAL,
  Mostrar_DOC_Cliente_na_Req,
  Nome_Telefone_Obrigatorios,
  Pedidos_em_Ordem_Decrescente,
  Conservante_Emb_Caps,
  Caminho_Txt_ECF_Chart,
  Caminho_Txt_ECF_ATS,
  IP_Comp_CodSeq_ECF_ATS,
  IP_Comp_CodSeq_ECF_SOFTPHARMA,
  Prazo_Duracao_Obrigatorio,
  Subst_Pr_Tot_Qdo_Desc_Neg,
  VERSAO_DE_ECF_CHART,
  DAVECF_HOM_ATIVO,
  Limite_Qde_Diaria_Formulas,
  Ordenar_Livro_por_Cod_Livro,
  Qde_Dias_Pesquisa_Pedidos,
  Tipo_Impressora_Requisicao,
  Definir_Excip_Pela_Prioridade,
  Utiliza_Crediario,
  Mostra_Taxa_Entr_no_DAV_ATS: string[30];
  // PARSIST2 - FIM
  NomeFantasiaAnterior: string[60];
  CodigoFornecAnt: String[4];
  CNPJAnt: String;

  // Valida Campos
  menorTabOrder: Integer;
  erro: TStringList;
  ListaNomeDBEditAlt: array[0..30,0..30] of String;
  validado: Boolean;
implementation

uses UChKProt, UDM, Variants;

{$R *.DFM}

// Para LogOn (copiar a funo inteira)
function PegarPermissoes: String;
var
  c: char;
  i: Short;
  PLetra: String[1];
  S1, S: String[60];
  NomeCrip: String[60];
  Senha: String[20];
begin
  if Usuario = '' then
  begin
    PegarPermissoes := '';
  end
  else
  begin
    DM.Usuarios.Open;
    Nome     := UpperCase(PL);
    PLetra   := copy(Nome,1,1);
    if not DM.Usuarios.FindKey([Usuario]) then
    begin
      //ShowMessage('Usurio ' + FormCadCaps.EditNome.text + ' no autorizado');
      PegarPermissoes := '';
    end
    else
    begin
      // Senha OK
      Permissoes             := DM.Usuarios.FieldByName('Acesso').AsString;
      PegarPermissoes        := Permissoes;
      DM.Usuarios.Close;
      c := Permissoes[7];
      i := ord(c) - 8;
      if chr(i) <> PLetra then
      begin
        PegarPermissoes := '';
      end;
    end; // not Usuarios.FindKey([NomeCrip])
    DM.Usuarios.Close;
  end; // EdNomeUsuario.text = ''
// At aqui (Para LogOn)
end;

function StrToEstilo(EstStr: String): TFontStyles;
begin
  if EstStr = 'TTTT' then StrToEstilo := [fsBold,fsItalic,fsUnderline,fsStrikeOut];
  if EstStr = 'TTTF' then StrToEstilo := [fsBold,fsItalic,fsUnderline];
  if EstStr = 'TTFT' then StrToEstilo := [fsBold,fsItalic,fsStrikeOut];
  if EstStr = 'TFTT' then StrToEstilo := [fsBold,fsUnderline,fsStrikeOut];
  if EstStr = 'FTTT' then StrToEstilo := [fsItalic,fsUnderline,fsStrikeOut];

  if EstStr = 'TTFF' then StrToEstilo := [fsBold,fsItalic];
  if EstStr = 'TFFT' then StrToEstilo := [fsBold,fsStrikeOut];
  if EstStr = 'TFTF' then StrToEstilo := [fsBold,fsUnderline];
  if EstStr = 'FTTF' then StrToEstilo := [fsItalic,fsUnderline];
  if EstStr = 'FTFT' then StrToEstilo := [fsItalic,fsStrikeOut];
  if EstStr = 'FFTT' then StrToEstilo := [fsUnderline,fsStrikeOut];

  if EstStr = 'TFFF' then StrToEstilo := [fsBold];
  if EstStr = 'FFFT' then StrToEstilo := [fsStrikeOut];
  if EstStr = 'FFTF' then StrToEstilo := [fsUnderline];
  if EstStr = 'FTFF' then StrToEstilo := [fsItalic];

  if EstStr = 'FFFF' then StrToEstilo := [];
  if EstStr = ''     then StrToEstilo := [];
end;

function EstiloToStr(Estilo: TFontStyles): String;
begin
  if Estilo = [fsBold,fsItalic,fsUnderline,fsStrikeOut] then EstiloToStr := 'TTTT';
  if Estilo = [fsBold,fsItalic,fsUnderline]             then EstiloToStr := 'TTTF';
  if Estilo = [fsBold,fsItalic,fsStrikeOut]             then EstiloToStr := 'TTFT';
  if Estilo = [fsBold,fsUnderline,fsStrikeOut]          then EstiloToStr := 'TFTT';
  if Estilo = [fsItalic,fsUnderline,fsStrikeOut]        then EstiloToStr := 'FTTT';

  if Estilo = [fsBold,fsItalic]         then EstiloToStr := 'TTFF';
  if Estilo = [fsBold,fsStrikeOut]      then EstiloToStr := 'TFFT';
  if Estilo = [fsBold,fsUnderline]      then EstiloToStr := 'TFTF';
  if Estilo = [fsItalic,fsUnderline]    then EstiloToStr := 'FTTF';

  if Estilo = [fsItalic,fsStrikeOut]    then EstiloToStr := 'FTFT';
  if Estilo = [fsUnderline,fsStrikeOut] then EstiloToStr := 'FFTT';

  if Estilo = [fsBold]                  then EstiloToStr := 'TFFF';
  if Estilo = [fsStrikeOut]             then EstiloToStr := 'FFFT';
  if Estilo = [fsUnderline]             then EstiloToStr := 'FFTF';
  if Estilo = [fsItalic]                then EstiloToStr := 'FTFF';
  if Estilo = []                        then EstiloToStr := 'FFFF';
end;

Function Converte_Codigo(Codigo: string): String;
begin
  Codigo := Lowercase(Codigo);
  Codigo := Uppercase(copy(Codigo,1,1))+
          copy(Codigo,2,length(Codigo)-1);
  if LowerCase(copy(Codigo,1,8)) = 'vitamina' then
  begin
    Codigo := copy(Codigo,1,9)+
            UpperCase(copy(Codigo,10,1))+
            copy(Codigo,11,length(Codigo)-10);
  end;
  Converte_Codigo := Codigo;
end;

procedure TFormFormulas.BotSairFormulasClick(Sender: TObject);
begin
  Close;
end;

procedure TFormFormulas.FormActivate(Sender: TObject);
begin
  PainelDeFormulas.Color  := CorFundo;
  FormFormulas.Color  := CorFundo;
  PainelDeFormulas.Visible := True;
  PainelDeFormulas.Tag := 0;
  DM.Especialidades.Open;
  BotSairFormulas.Cancel := True;

  Usuario := GetNetUserName;
  EditNome.Text := Usuario;
  FormFormulas.PainelDeFormulas.Visible := False;
  FormFormulas.PainelLogin.Height  := 130;
  FormFormulas.PainelLogin.Left    :=  78;
  FormFormulas.PainelLogin.Top     := 184;
  FormFormulas.PainelLogin.Width   := 331;
  FormFormulas.PainelLogin.Visible := True;
  FormFormulas.EditSenhaU.Enabled  := True;
  FormFormulas.EditSenhaU.Visible  := True;
  FormFormulas.EditNome.SetFocus;
  FormFormulas.BotCancSenha.Cancel := True;
  menorTabOrder := 100;
end;

function Limparametro(S: String): string;
begin
  // Limpa os brancos  esquerda
  while Copy(S,1,1) = ' '         do S := Copy(S,2,Length(S)-1);
  // Limpa os brancos  direita
  while Copy(S,Length(S),1) = ' ' do S := Copy(S,1,Length(S)-1);
  Result := S;
end;

procedure Ler_Parametros_de_Sistema;
var
  F: TextFile;
  S: string;
  NomeParametro, ValorParametro: string[60];

begin
  PastaEXE   := ExtractFilePath(Application.ExeName);
  AssignFile(F,PastaEXE+'LAGFARMA.INI');
  if FileExists(PastaEXE+'LAGFARMA.INI') then
  begin
    // O arquivo LAGFARMA.INI existe e ser lido aqui agora
    Reset(F);
    while not Eof(F) do
    begin
      Readln(F,S);
      NomeParametro  := Copy(S,1,48);
      ValorParametro := Copy(S,50,60);
      if Copy(S,1,48) = 'IP DO SERVIDOR CENTRAL.........................:' then
        IPServidor := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IP DA ESTACAO DO USUARIO.......................:' then
        IPEstacao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IP DO BACKUP DO BD LOCAL (BKPPED)..............:' then
        IPBkpPed := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IP DO BACKUP DO BD CENTRAL.....................:' then
        IPBackup := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CAMINHO DO BACKUP MANUAL DO BD DO SISTEMA......:' then
        CaminhoBkp := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'COR DE FUNDO DAS TELAS.........................:' then
        CorFundo := StrToInt(Limparametro(ValorParametro));
      if Copy(S,1,48) = 'LOG DE ATIVIDADES..............................:' then
        FazLog := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TIT.COL 4 F.FARMACEUTICA..(Preco Min./% Lucro).:' then
        TitCol4FormaFar := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PADRAO PRECO MINIMO............................:' then
        Padrao_Pr_Min := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'BOTAO MANIPULACAO EM ABERTO/EFETUADA...........:' then
        Botao_Manip_em_Aberto := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MODELO DA REQUISICAO...........................:' then
        Modelo_da_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR F.C. NO PRECO DE VENDA....................:' then
        Usar_FC_no_Pr_Venda := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ATENDENTE OBRIGATORIO..........................:' then
        Atendente_Obrigatorio := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR PRESCRICAO COMPLETA NA REQUISICAO......:' then
        Mostrar_Precricao_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR DESCONTO NA REQUISICAO.................:' then
        Mostrar_Desconto_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR PRECO PADRAO DAS FORMULAS PREDEFINIDAS....:' then
        Usar_Preco_Formula_Predefinida := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LAGURA DA REQUISICAO (QDE TRACOS)..............:' then
        Largura_da_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR CONVENIO NA REQUISICAO.................:' then
        Mostra_Convenio_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'SALTO FINAL APOS IMPRESSAO DA REQUISICAO.......:' then
        Salto_Final_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LOG ATIVADO....................................:' then
        LOG_Ativado := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR PRECO MINIMO POR FRASCO...................:' then
        Usar_Preco_Minimo_por_Frasco := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ARREDONDAMENTO DO PRECO (1, 5, 10, 50, 100)....:' then
        Arredondamento := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MARGEM ESQUERDA DA REQUISICAO..................:' then
        Margem_Esquerda_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR POSOLOGIA NA REQUISICAO................:' then
        Incluir_Posologia_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LARGURA DA OM (QDE TRACOS).....................:' then
        Largura_da_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MARGEM ESQUERDA DA OM..........................:' then
        Margem_Esquerda_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'EMBALAGEM OBRIGATORIA..........................:' then
        Embalagem_Obrigatoria := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR VALIDADE NA REQUISICAO.................:' then
        Mostrar_Validade_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'FORMATA NOME DO CLIENTE........................:' then
        Formata_Nome_Cliente := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR ENDERECO NA REQUISICAO.................:' then
        Mostrar_Endereco_na_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'REQUISICAO EM 1 OU 2 VIAS......................:' then
        Separacao_entre_colunas_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ALERTAR QUANDO VALIDADE MENOR QUE N (DIAS).....:' then
        Alerta_sobre_Validade := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'FORMA DE PAGAMENTO OBRIGATORIA.................:' then
        Forma_Pagto_Obrigatoria := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'INCLUIR OBSERVACAO NA REQUISICAO...............:' then
        Incluir_Obs_na_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'QDE DIAS PARA ENTREGA APOS SEXTA FEIRA.........:' then
        Qde_Dias_Apos_Sexta := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'QDE DIAS PARA ENTREGA APOS SEG A QUI...........:' then
        Qde_Dias_Apos_Outros_Dias := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR HOMEOPATIA E FLORAIS......................:' then
        Usar_Homeopatia := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'QDE GOTAS POR ML DO CONTA-GOTAS................:' then
        Qde_Gotas_Conta_Gotas := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CALCULAR PRECOS HOMEOPATIA PELA QDE DE GOTAS...:' then
        Preco_Hom_pela_QdeGotas := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'HABILITAR BOTAO "REPETIR PEDIDO"...............:' then
        Habilita_Repetir_Pedido := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PARA O PRODUTO MANIPULADO, USAR A VALIDADE.....:' then
        Tipo_Validade_a_Usar := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR NOME FORMULA PRE-DEFIN NA REQ E NO ROTULO.:' then
        Usar_Nome_Form_Predefinida := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'UNID USADA P/ COMPRIM E GLOBULOS NA HOMEOPATIA.:' then
        Unidade_Comprimidos_Homeopatia := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR MATRICULA NA REQUISICAO................:' then
        Mostrar_Matricula_na_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'FORMATO DA VALIDADE DA FORMULA.................:' then
        Formato_da_Validade := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VALOR DA HORA DE MANIPULACAO...................:' then
        Valor_Hora_Manipulacao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ROTULO DADO AO CAMPO DE CUSTO DA FORMULA.......:' then
        Identificacao_Campo_Custos := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'BLOQUEIO DA ALTERACAO DO PEDIDO APOS IMPRESSAO.:' then
        Bloqueio_Alteracao_Pedido := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IMPRESSAO OBRIGATORIA DA REQUISICAO............:' then
        Impressao_Obrigatoria := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MODELO ALTERNATIVO DE REQUISICAO...............:' then
        Modelo_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IMPRIMIR NA REQ. CABECALHO PORTARIA 3492 ART.68:' then
        Cabecalho_Portaria_3492 := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ATUALIZAR DATAS SE FOR ALTER. O TIPO DO PEDIDO.:' then
        Recalc_Data_Pedido := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TEXTO PADRAO DA POSOLOGIA......................:' then
        Texto_Padrao_Posologia := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR CAMPO DE CODIGO DE ENTREGA.............:' then
        Mostrar_Codigo_Entrega := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PERMITIR PRODUTO DE REVENDA NA FORMULA.........:' then
        Permitir_Prod_REV := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR CAMPOS DO CAIXA NA TELA DE PEDIDOS.....:' then
        Mostrar_Campos_Caixa := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'COR PADRAO DAS CAPSULAS........................:' then
        Cor_Padrao_Capsulas := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TEXTO DO CAMPO DE CONVENIO.....................:' then
        Texto_Campo_Convenio := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VISUALIZAR SITUACOES ESPECIAIS DOS COMPONENTES.:' then
        Visualizar_Situacoes_Especiais := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LABORATORIO PADRAO.............................:' then
        Laboratorio_Padrao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'POSOLOGIA OBRIGATORIA..........................:' then
        Posologia_Obrigatoria := Limparametro(ValorParametro);

      if Copy(S,1,48) = 'NOME DO CONVENIO PADRAO........................:' then
        Posologia_Obrigatoria := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR FAT. DILUICAO NO CALC. DO PRECO DE VENDA..:' then
        Usar_FD_no_Calc_Preco_Venda := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'OBRIGA ESPECIFICAR ROTA NAS ENTREGAS EM DOMIC..:' then
        Rota_Obrigatoria := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'INCLUIR DADOS CLIENTE NA REQ. (ENTR. DOMICILIO):' then
        Inclir_dados_cliente := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PERMITE FORMULA HOM SEM ESTOQUE DINAM INFERIOR.:' then
        Permite_Form_Hom_Sem_Estoq := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ATIVAR MODO DE IMPLANTACAO DO SISTEMA..........:' then
        Ativar_modo_implantacao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IMPEDE DIGITACAO DO NOME DO ATENDENTE..........:' then
        Impede_digitar_nome_atendente := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TEMPO PARA LOGOFF AUTOMATICO...................:' then
        Tempo_para_Logoff_automatico := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'USAR REDUCAO FRASCOS PARA DOSE UNICA.(QDEDU)...:' then
        Usar_red_qde_fr_para_DoseUnica := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'EXIBIR BOTAO PLACEBO NA TELA DE HOMEOPATIA.....:' then
        Exibir_botao_placebo := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LIMITE DE REG MANTIDOS PARA QUIT AUTOMATICA....:' then
        Limite_reg_quitacao_automat := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TIT.COL 4 F.FARMACEUTICA..(Preco Min./% Lucro).:' then
        TitCol4FormaFar := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'UTILIZAR TABELA DE ACRESCIMOS DA HOMEOPATIA....:' then
        Utillizar_tab_AcrescHom := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CALCULAR PRECOS FLORAIS COM BASE NA............:' then
        Precos_Florais_ComBaseNa := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PRECOS HOM COM ASSOCIACOES COM BASE............:' then
        Precos_Hom_Assoc_ComBase := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'COR DAS MENSAGENS DOS COMPONENTES..............:' then
        Cor_Mensagens_Componentes := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'COR USADA NAS MENSAGEM DE SITUACOES ESPECIAIS..:' then
        Mudanca_cor_sit_especiais := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'INCLUIR EXCIPIENTES E VEICULOS NOS ROTULOS.....:' then
        Incluir_Exc_e_Vei_nos_Rotulos := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR PRECO NA OM E NA REQUISICAO............:' then
        Incluir_Preco_na_OM_e_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'INCLUIR TEXTO "PEDIDO" OU "ORCAM" NA REQUISICAO:' then
        Incluir_Texto_Pedido_Orcam_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MASCARA P/ FORMATACAO DO N.PEDIDO NA REQUISICAO:' then
        Mascara_Formatar_N_Pedido := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'OCULTAR BOTAO "INSERIR" NA PESQUISA DE MEDICO..:' then
        Ocultar_Insert_Medico := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'REPETIR MESMA OBS DA FORMULA AO REPETIR PEDIDO.:' then
        Repetir_OBS_ao_Repetir_Pedido := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IMPEDIR A REIMPRESSAO DA REQUISICAO............:' then
        Impedir_Reimpressao_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'FORMA DE INCLUSAO DA EMBALAGEM DA FORMULA......:' then
        Inclusao_Embalagem := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'PREENCHIMENTO OBRIGATORIO DOS DADOS DO SNGPC...:' then
        Obrig_Preench_Dados_SNGPC := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ECF UTILIZADO..................................:' then
        Utilizacao_de_ECF := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR OS EXCIPIENTES IDENTIFICADOS NA FORMULA:' then
        Mostrar_Excipiente_Formula := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DEFINIR O EXCIPIENTE PELA DOSAGEM..............:' then
        Definir_o_excip_pela_dosagem := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VALOR DESC. P/ FLORAIS COM APENAS UMA ESSENCIA.:' then
        Valor_Desconto_Florais := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VAL DESC P/ FLORAIS C/ NO MAXIMO 20% DE BRANDY.:' then
        Valor_Desc_Brandy := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR CAMPO DE SINAL NA TELA DE PEDIDOS......:' then
        Mostrar_Campo_SINAL := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR NUM. DOCUMENTO DO CLIENTE NA REQUISICAO:' then
        Mostrar_DOC_Cliente_na_Req := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'OBRIGATORIO NOME/TELEFONE DO CLIENTE NO PEDIDO.:' then
        Nome_Telefone_Obrigatorios := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CONSERVANTE ADICION. NAS EMBALAGENS DE CAPSULAS:' then
        Conservante_Emb_Caps := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CAMINHO ARQ TEXTO PARA ECF CHART...............:' then
        Caminho_Txt_ECF_Chart := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CAMINHO ARQ TEXTO PARA ECF ATS.................:' then
        Caminho_Txt_ECF_ATS := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IP COMPUTADOR QUE GERA COD.SEQ. PARA ECF ATS...:' then
        IP_Comp_CodSeq_ECF_ATS := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IP COMPUT. QUE GERA COD.SEQ. P/ ECF SOFTPHARMA.:' then
        IP_Comp_CodSeq_ECF_SOFTPHARMA := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'SUBST PR.TOT P/ PR.C/.DESC QDO DESC FOR NEGAT..:' then
        Subst_Pr_Tot_Qdo_Desc_Neg := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VERSAO DO ECF CHART............................:' then
        VERSAO_DE_ECF_CHART := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DAV/ECF ATIVO..................................:' then
        DAVECF_HOM_ATIVO := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'LIMITE DA QUANTIDADE DIARIA DE FORMULAS........:' then
        Limite_Qde_Diaria_Formulas := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ORDENAR LIVRO RECEIT. PELO COD. LIVRO..........:' then
        Ordenar_Livro_por_Cod_Livro := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'QDE PADRAO DE DIAS PARA PESQUISA DE PEDIDOS....:' then
        Qde_Dias_Pesquisa_Pedidos := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TIPO DE IMPRESSORA DA REQUISICAO...............:' then
        Tipo_Impressora_Requisicao := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DEFINIR EXCIPIENTE PELA PRIORIDADE.............:' then
        Definir_Excip_Pela_Prioridade := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'UTILIZA CREDIARIO..............................:' then
        Utiliza_Crediario := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'INCLUIR TAXA ENTREGA NO DAV DA ATS.............:' then
        Mostra_Taxa_Entr_no_DAV_ATS := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'OBRIGATORIO INFORMAR PRAZO DURACAO DA FORMULA..:' then
        Prazo_Duracao_Obrigatorio := Limparametro(ValorParametro);


      if Copy(S,1,48) = 'MOSTRAR OBS SOBRE DOSAGEM FORA DA FAIXA NO OM..:' then
        Mostrar_Obs_Dosag_ForaDaFaixa := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'ALTURA DA PAGINA DA OM.........................:' then
        Altura_da_Pagina_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MARGEM SUPERIOR DA OM..........................:' then
        Margem_Superior_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'SALTO FINAL APOS IMPRESSAO DA OM...............:' then
        Salto_Final_Apos_Impr_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MODELO DA OM...................................:' then
        Modelo_da_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'FECHAR CAIXA DE DIALOGO APOS IMPRESSAO DA OM...:' then
        Fechar_CX_Dialogo := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'EM CASO DE DESDOBR, QDE CAPS A INFORMA NA OM...:' then
        Qde_Caps_Se_Desdobr := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'EM CASO DE DESDOBR, QDE CAPS A INFORMA NA OM...:' then
        Qde_Caps_Se_Desdobr := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR NOME DA FORMULA PREDEFINIDA NA OM......:' then
        Mostrar_nome_Form_PreDef := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR FICHA TECNICA DO MEDICAMENTO NA OM.....:' then
        Mostra_Ficha_Tecnica := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR O CONVENIO NA OM.......................:' then
        Mostra_Convenio_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR INFORM. MEDICAS DO PACIENTE NA OM......:' then
        Incluir_Infor_Med_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'CONVERTER A UNIDADE ML PARA G NA OM............:' then
        Converter_ML_para_G_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'MOSTRAR DENSIDADE DO COMPONENTE NA OM..........:' then
        Mostrar_Densidade_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DESTACA OBS NA OM..............................:' then
        Destaca_OBS_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'GERA/MOSTRA NA OM LOTES P/ FORM FEITAS EM CONJ.:' then
        Gera_Lote := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'IMPRIME UM TRACO HORIZONTAL NO FINAL DA OM.....:' then
        Impr_TracoHoriz_no_Final_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DEIXA ESPACO P/ PREENCH MAN. DE EXCIP E VEICULO:' then
        Permite_Preench_Man_Excip_Vei := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'UTILIZA PARAM DE CONTROLE DE QUALIDADE NA OM...:' then
        Utiliza_Param_CQ_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'DETALHAR EXCIPIENTE DA FORMULA NA OM...........:' then
        Detalhar_Excip_da_Form_na_OM := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'TEXTO REFERENTE A QUANTIDADE REAL A SER PESADA.:' then
        Texto_Ref_Qde_Real_a_Pesar := Limparametro(ValorParametro);
      if Copy(S,1,48) = 'VOLUME TOTAL DA FORMULA A SER MOSTRADO NA OM...:' then
        Volume_Total_Formula := Limparametro(ValorParametro);
    end;
    CloseFile(F);
  end
  else
  begin
    ShowMessage('Arquivo LAGFARMA.INI no encontrado. Execute o programa MigraTab.exe para cri-lo.');
    Halt;
  end;
end;

procedure TFormFormulas.FormCreate(Sender: TObject);
begin
  Height  := 666;
  Width   := 507;
  Position := poScreenCenter;
  Ler_Parametros_de_Sistema;
end;

procedure TFormFormulas.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  compascal: String;
  comando: array[0..255] of Char;
begin
  try
    DM.Especialidades.Post;
  except
  end;
  DM.Especialidades.Close;
end;

procedure BotaoOkSenha;
var
  c: char;
  i: Short;
  PLetra: String[1];
  S1, S: String[60];
  NomeCrip: String[60];
  Senha: String[20];
begin
  if FormFormulas.EditNome.text = '' then
  begin
    ShowMessage('No foi informado o Nome do Usurio.');
    FormFormulas.EditNome.SetFocus;
  end
  else
  begin
    DM.Usuarios.Open;
    Nome     := UpperCase(FormFormulas.EditNome.text);
    PLetra   := copy(Nome,1,1);
    NomeCrip := CriptStr(UpperCase(FormFormulas.EditNome.text));
    if not DM.Usuarios.FindKey([NomeCrip]) then
    begin
      ShowMessage('Usurio ' + FormFormulas.EditNome.text + ' no autorizado');
      FormFormulas.EditNome.SetFocus;
    end
    else
    begin
      Senha := DM.Usuarios.FieldByName('Senha').AsString;
      if CriptStr(UpperCase(FormFormulas.EditSenhaU.Text)) <> Senha then
      begin
        ShowMessage('Senha incorreta. Tente novamente.');
        FormFormulas.EditSenhaU.SetFocus;
      end
      else
      begin
        // Senha OK
        Permissoes             := DM.Usuarios.FieldByName('Acesso').AsString;
        DM.Usuarios.Close;
        c := Permissoes[4];
        i := ord(c) - 5;
        if chr(i) = PLetra then
        begin
          FormFormulas.PainelLogin.Visible    := False;
          FormFormulas.EditNome.text := '';
          FormFormulas.EditSenhaU.text := '';
          FormFormulas.PainelDeFormulas.Visible := True;
          FormFormulas.BotSairFormulas.Cancel  := True;
          FormFormulas.BotCancSenha.Cancel := False;
          FormFormulas.PainelPesquisa.Visible := True;
          try
            FormFormulas.BotSairFormulas.SetFocus
          except
          end;
          Usuario := Nome;
          if Area_de_Trabalho = '' then
          begin
            ShowMessage('No foi identificada uma rea de trabalho para o usuro '+UpperCase(FormFormulas.EditNome.text));
            FormFormulas.Close;
          end;
        end
        else
        begin
          ShowMessage('Usurio ' + FormFormulas.EditNome.text + ' no autorizado');
          FormFormulas.DBGrid1.SetFocus;
          FormFormulas.DBGrid1.SelectedIndex := 1;
        end;
      end; // CriptStr(EdSenha.Text) <> Senha
    end; // not Usuarios.FindKey([NomeCrip])
    DM.Usuarios.Close;
  end; // EdNomeUsuario.text = ''
end;

procedure TFormFormulas.BotOkSenhaClick(Sender: TObject);
begin
  BotaoOkSenha;
end;

procedure TFormFormulas.BotCancSenhaClick(Sender: TObject);
begin
  PainelLogin.Visible := False;
  Close;
end;

procedure TFormFormulas.EditNomeExit(Sender: TObject);
begin
  EditNome.text := UpperCase(EditNome.text);
end;

procedure TFormFormulas.EditNomeKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    Perform(wm_NextDlgCtl, 0, 0);
  end;
end;

procedure TFormFormulas.EditSenhaUKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    BotaoOkSenha;
  end;
end;

procedure TFormFormulas.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then
  begin
    Key := #0;
    try
      DM.Especialidades.Post;
    except
    end;
  end;
end;


end.
