unit UDM;

interface

uses
  SysUtils, Classes, FMTBcd, DBXpress, DB, SqlExpr, DBClient, Provider,
  DBTables, Dialogs, Graphics, WinTypes, DBCtrls, Forms;

type
  TDM = class(TDataModule)
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    SQLDS_Espec: TSQLDataSet;
    DSP_Espec: TDataSetProvider;
    Especialidades: TClientDataSet;
    DS_Espec: TDataSource;
    SQLDS_Usuarios: TSQLDataSet;
    SQLDS_UsuariosUSUARIO: TStringField;
    SQLDS_UsuariosCODIGO: TStringField;
    SQLDS_UsuariosSENHA: TStringField;
    SQLDS_UsuariosACESSO: TStringField;
    SQLDS_UsuariosARQUIVO: TStringField;
    SQLDS_UsuariosLOGADO: TStringField;
    SQLDS_UsuariosESTACAO: TStringField;
    SQLDS_UsuariosCONSIST_INICIAL: TStringField;
    SQLDS_UsuariosDEFVIDEOLAG: TIntegerField;
    DSP_Usuarios: TDataSetProvider;
    Usuarios: TClientDataSet;
    UsuariosUSUARIO: TStringField;
    UsuariosCODIGO: TStringField;
    UsuariosSENHA: TStringField;
    UsuariosACESSO: TStringField;
    UsuariosARQUIVO: TStringField;
    UsuariosLOGADO: TStringField;
    UsuariosESTACAO: TStringField;
    UsuariosCONSIST_INICIAL: TStringField;
    UsuariosDEFVIDEOLAG: TIntegerField;
    DS_Usuarios: TDataSource;
    SQLDS_Estacoes: TSQLDataSet;
    SQLDS_EstacoesESTACAO: TStringField;
    SQLDS_EstacoesDATBASNAM: TStringField;
    SQLDS_EstacoesTIPO: TStringField;
    SQLDS_EstacoesATCAIXA: TStringField;
    SQLDS_EstacoesESVAZIAR: TStringField;
    SQLDS_EstacoesEMUSO: TStringField;
    SQLDS_EstacoesCAMINHOREQUISICAO: TStringField;
    SQLDS_EstacoesCAMINHOOM: TStringField;
    SQLDS_EstacoesCAMINHOECF: TStringField;
    SQLDS_EstacoesCAMINHOSEQUENCIAL1: TStringField;
    SQLDS_EstacoesCAMINHO2: TStringField;
    SQLDS_EstacoesROTULO1: TStringField;
    SQLDS_EstacoesROTULO2: TStringField;
    SQLDS_EstacoesROTULO3: TStringField;
    SQLDS_EstacoesROTULO4: TStringField;
    SQLDS_EstacoesROTULO5: TStringField;
    SQLDS_EstacoesROTULO6: TStringField;
    SQLDS_EstacoesUSUARIO: TStringField;
    DSP_Estacoes: TDataSetProvider;
    Estacoes: TClientDataSet;
    EstacoesESTACAO: TStringField;
    EstacoesDATBASNAM: TStringField;
    EstacoesTIPO: TStringField;
    EstacoesATCAIXA: TStringField;
    EstacoesESVAZIAR: TStringField;
    EstacoesEMUSO: TStringField;
    EstacoesCAMINHOREQUISICAO: TStringField;
    EstacoesCAMINHOOM: TStringField;
    EstacoesCAMINHOECF: TStringField;
    EstacoesCAMINHOSEQUENCIAL1: TStringField;
    EstacoesCAMINHO2: TStringField;
    EstacoesROTULO1: TStringField;
    EstacoesROTULO2: TStringField;
    EstacoesROTULO3: TStringField;
    EstacoesROTULO4: TStringField;
    EstacoesROTULO5: TStringField;
    EstacoesROTULO6: TStringField;
    EstacoesUSUARIO: TStringField;
    SQLDS_EstacoesCNPJ: TStringField;
    EstacoesCNPJ: TStringField;
    SQLDS_EspecCODIGO_ESPEC: TIntegerField;
    SQLDS_EspecESPECIALIDADE: TStringField;
    EspecialidadesCODIGO_ESPEC: TIntegerField;
    EspecialidadesESPECIALIDADE: TStringField;
    procedure DataModuleCreate(Sender: TObject);
    procedure EspecialidadesAfterInsert(DataSet: TDataSet);
    procedure EspecialidadesAfterDelete(DataSet: TDataSet);
    procedure EspecialidadesAfterPost(DataSet: TDataSet);
    procedure EspecialidadesBeforePost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  DM: TDM;
  function GetNetUserName: string;
  Function Area_de_Trabalho: String;

implementation

uses UEspec, Windows;

{$R *.dfm}

function GetNetUserName: string;
var
  NetUserNameLength: DWord;
begin
  NetUserNameLength := 50;
  SetLength(Result, NetUserNameLength);
  GetUserName(pChar(Result), NetUserNameLength);
  SetLength(Result, StrLen(pChar(Result)));
end;

Function Area_de_Trabalho: String;
begin
  EstLocal         := '';   // ESTLOCAL  a vrivel OFICIAL de identificao da ESTAO CORRENTE em todo o mdulo PEDIDOS.EXE
  Area_de_Trabalho := '';

  FormFormulas.EditNome.Text := Usuario;
  DM.Estacoes.Close;
  DM.SQLDS_Estacoes.CommandText := 'Select ESTACAO, DATBASNAM, TIPO, ATCAIXA, ESVAZIAR, EMUSO, CAMINHOREQUISICAO, CAMINHOOM, CAMINHOECF, CAMINHOSEQUENCIAL1, CAMINHO2, ROTULO1, ROTULO2, ROTULO3, ROTULO4, ROTULO5, ROTULO6, USUARIO, CNPJ '+
                                   'from ESTACOES where upper(USUARIO) = '''+Uppercase(Usuario)+'''';
  DM.Estacoes.Open;
  if UpperCase(DM.EstacoesUSUARIO.AsString) = UpperCase(Usuario) then
  begin
    EstLocal            := DM.Estacoes.FieldByName('Estacao').AsString;
    Area_de_Trabalho    := DM.Estacoes.FieldByName('DatBasNam').AsString;
    FormFormulas.Caption := ' Especialidades - Usurio: "'+Usuario+'" Estao: '+EstLocal;
    DM.Estacoes.Edit;
    DM.Estacoes.FieldByName('EmUso').AsString := 'S';
    DM.Estacoes.FieldByName('AtCaixa').AsString := 'Ultima atividade: '+FormatDateTime('dd/mm/yy',Date)+' '+FormatDateTime('hh:nn:ss',Now);
    DM.Estacoes.Post;
  end
  else
  begin
    Area_de_Trabalho := '';
    ShowMessage('No foi possvel selecionar uma rea de trabalho para o usurio "'+Usuario+'". '+#13+#13+
                'Causas provveis: '+#13+#13+
                '  1) Na tabela "Estacoes.db" no foi includa uma estao para o usurio "'+Usuario+'".'+#13+
                '     Obs: Criar tambm a rea de trabalho fsica (pasta C:\Lagfarma\InterfacXX) para este usurio.'+#13+
                '  --> Favor contactar o suporte tcnico da LAG SISTEMAS <--');
  end;
  DM.Estacoes.Close;
end;

procedure TDM.DataModuleCreate(Sender: TObject);
var
  F: TextFile;
  CaminhoGDS: String[100];
begin
  // Pegar caminho do GDS32.dll (necessario para Win Server 2003)
  CaminhoGDS := '';
  AssignFile(F,'c:\lagfarma\CaminhoGDS.txt');
  if FileExists('c:\lagfarma\CaminhoGDS.txt') then
  begin
    Reset(F);
    Readln(F,CaminhoGDS);
  end;
  if CaminhoGDS <> '' then
  begin
    if copy(CaminhoGDS,length(CaminhoGDS),1) <> '\' then
      CaminhoGDS := CaminhoGDS + '\';
    SQLConnection1.VendorLib := CaminhoGDS+'GDS32.DLL';
  end;
  DM.SQLConnection1.Connected := False;

  SQLConnection1.Params.Values['DataBase'] := IPServidor+':C:\lagfarma\dados\lagfarma.bd';

end;

procedure TDM.EspecialidadesAfterInsert(DataSet: TDataSet);
var
  MaiorI: Integer;
  NovoCod: string[20];
begin
  if not Migrando then
  begin
    SQLQuery1.Close;
    SQLQuery1.SQL.Text := 'Select CODIGO_ESPEC from ESPECIALIDADES ORDER BY CODIGO_ESPEC DESC';
    SQLQuery1.Open;
    NovoCod := '0001';
    While not SQLQuery1.Eof do
    begin
      if NovoCod < FormatFloat('0000',SQLQuery1.FieldByName('Codigo_Espec').AsInteger+1) then
        NovoCod := FormatFloat('0000',SQLQuery1.FieldByName('Codigo_Espec').AsInteger+1);
      SQLQuery1.Next;
    end;
    try
      EspecialidadesCODIGO_ESPEC.AsString  := NovoCod;
    except
      EspecialidadesCODIGO_ESPEC.AsString  := '0001';
    end;
    SQLQuery1.Close;
    FormFormulas.DBGrid1.SetFocus;
  end;
end;

procedure TDM.EspecialidadesAfterDelete(DataSet: TDataSet);
begin
  Especialidades.ApplyUpdates(0);
  Especialidades.Refresh;
end;

procedure TDM.EspecialidadesAfterPost(DataSet: TDataSet);
begin
  Especialidades.ApplyUpdates(0);
  Especialidades.Refresh;
end;

procedure TDM.EspecialidadesBeforePost(DataSet: TDataSet);
begin
  DM.EspecialidadesESPECIALIDADE.AsString := UpperCase(Copy(DM.EspecialidadesESPECIALIDADE.AsString,1,1))+LowerCase(Copy(DM.EspecialidadesESPECIALIDADE.AsString,2,49));
end;

end.
